<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 30/08/13
 * Time: 14:29
 * To change this template use File | Settings | File Templates.
 */

namespace BancoTalentos\Logic\Mail;


use BancoTalentos\Logic\BTL;

class ConfirmaCadastro {

    const SUBJECT_CADASTRO = 'Cadastre seu currículo';
    /**
     * Envia email para operador informando a ele sua nova senha.
     * @param string $email Email do operador que tera sua senha enviada.
     * @return void
     * @author leonardocarvalho
     */
    public static function enviaConfirmacaoCadastro($nmoperador, $email){

        try{

            $subject = self::SUBJECT_CADASTRO;
            $content = self::mailNovoCadastro($nmoperador);

            // Manda um email para operador notificando cadastro
            new Mail($email, $subject, $content);

        }
        catch(\Exception $e){
            // throw new \Exception($e->getMessage(), $e->getCode());
            tk_show_message_by_name($e->getMessage());
        }

    }


    //tempalte para email de confirmação de cadastro.
    private function mailNovoCadastro($nmoperador){

        $nrorg = BTL::getNrorg();
        $link = 'http://recrutamento.pebbian.com/'.BTL::getNmacessoOrg().'/';
        $content = "Olá <b>".$nmoperador."</b>";
        $logo_bottom = 'http://vagas.pebbian.com/images/pebbian_logotipo.png';
        $logo_organização = 'http://rh.pebbian.com/images/logo/'.$nrorg.'-logo.png';

        $template = <<<HTML
                        <!--<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> -->
                        <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
                        <html>
                        <head>
                            <title>Recuperação de Senha</title>
                        </head>
                        <body style="text-align: center; padding-top: 2%; padding-left: 22%; background-color: rgb(118, 192, 179); margin: 0px; height: auto;">
                            <div style="width:672px; height:375px; box-shadow: 10px 10px 5px #78887d;">
                                <table cellpadding="0" cellspacing="0" style="width: 674px; height: 375px; margin: 0 auto;">
                                    <tr style="background-color: #FFF">
                                        <td height="20">
                                            &nbsp;
                                        </td>
                                    </tr>
                                    <tr style="background-color: #FFF;">
                                        <td style="text-align: center;">
                                            <img src="$logo_organização" />
                                        </td>
                                    </tr>
                                    <tr style="background-color: #FFF">
                                        <td height="35">
                                            &nbsp;
                                        </td>
                                    </tr>
                                    <tr style="background-color: #FFF; text-align: left; font: normal 14px Arial, Tahoma, sans-serif; color: #333;">
                                        <td>
                                            <table cellpadding="0" cellspacing="0">
                                                <tr>
                                                    <td width="24"></td>
                                                    <td height="193">
                                                        <h1 style="font-size: 30px; margin: 0 0 15px 0; color: #76c0b3;">Olá $nmoperador</h1>
                                                        <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                            $content
                                                        </p>
                                                        <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                            Seu curriculo foi cadastrado em nosso banco de talentos, fique atento aos nossos processos seletivos.
                                                        </p>
                                                        <br /> <br />
                                                        <p style="margin: 0; padding: 0 0 12px 0; line-height: 17px; text-align: justify;">
                                                            Acesse sua conta neste <a href=$link>link </a>.
                                                        </p>
                                                    </td>
                                                    <td width="24"></td>
                                                </tr>
                                            </table>
                                        </td>
                                    </tr>
                                    <tr style="background-color: #FFF">
                                        <td>
                                            &nbsp;
                                        </td>
                                    </tr>
                                    <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                        <td height="17">
                                            &nbsp;
                                        </td>
                                    </tr>
                                    <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                        <td align="center">
                                        Tem alguma dúvida? Quer nos dar sugestões? <b>Entre em contato conosco</b> contato@alibras.com.br
                                        </td>
                                    </tr>
                                    <tr style="background-color: #1b9772; color: #FFF; font: normal 13px Arial, Tahoma, sans-serif;">
                                        <td height="10">
                                            &nbsp;
                                        </td>
                                    </tr>

                                </table>
                            </div>
                        </body>
                        </html>
HTML;

                return $template;

            }

}