<?php

namespace Folha\Logic\ValesBeneficios\CalculoValeTransporte;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\FPA\Entity\FpatipocalculoEntity;

class MemoriaVT{

    private static $instance = null;
    private static $contador = 0;
    
    private $nomeArquivo = null;
    private $escopoGeral = "";
    private $escopoVinc = null;

    private $qtdeFerias;
    private $detalhesFerias;
    private $qtdeDiasAfastAtest;
    private $detalhesAfastAtest;
    private $qtdeFaltas;
    private $qtdeDiasAviso;
    private $qtdeDiasConsPeriodo;
    private $detalhesDiasConsPeriodo;
    private $qtdeDiasComposicaoMensal;
    private $qtdeDiasObrigacaoSind;
    private $idNaoGeraCalc;
    private $resultadoTotal;
    
    private $referencia;
    
    private $infoValesVinc = [];
    private $impeditivosParaGerarVale = [];
    
    private $vinculo;
    private $dtInicial;
    private $dtFinal;
    private $dtPagamento;

    private $geraInfoCalc;

    private $arquivo;
    
    public function inicializarDados($vinculo, $hcmParameters, $dtInicial, $dtFinal, $dtPagamento){
        $this->qtdeFerias = null;
        $this->detalhesFerias = null;
        $this->qtdeDiasAfastAtest = null;
        $this->detalhesAfastAtest = [];
        $this->qtdeFaltas = null;
        $this->qtdeDiasAviso = null;
        $this->qtdeDiasConsPeriodo = null;
        $this->detalhesDiasConsPeriodo = null;
        $this->qtdeDiasComposicaoMensal = null;
        $this->qtdeDiasObrigacaoSind = null;
        $this->idNaoGeraCalc = null;
        $this->resultadoTotal = null;
        
        $this->geraInfoCalc = false;
        
        $this->referencia = null;
        
        $this->infoValesVinc = [];
        $this->impeditivosParaGerarVale = [];
        
        $this->vinculo = $vinculo;
        $this->dtInicial = $dtInicial->format('d/m/Y');
        $this->dtFinal = $dtFinal->format('d/m/Y');
        $this->dtPagamento = $dtPagamento->format('d/m/Y');
    }
    
    public function setReferencia($booleano){
        $this->referencia = $booleano;
    }

    public function setDiasComposicaoMensal($nrDiasApurVale){
        $this->qtdeDiasComposicaoMensal = $nrDiasApurVale;
    }

    public function setDiasObrigacaoSindicato($nrDiasApurVale){
        $this->qtdeDiasObrigacaoSind = $nrDiasApurVale;
    }

    public function setDiasAfastAtest($total){
        $this->qtdeDiasAfastAtest = $total;
    }
    
    public function detalharDiasAfastAtest($dados){
        $this->detalhesAfastAtest[] = $dados;        
    }

    public function setFaltas($total){
        $this->qtdeFaltas = $total;
    }

    public function setFerias($total){
        $this->qtdeFerias = $total;
    }
    
    public function detalharFerias($dados){
        $this->detalhesFerias = $dados;
    }

    public function setDiasAviso($diasAviso){
        $this->qtdeDiasAviso = $diasAviso;
    }

    public function setIdNaoGeraCalc($geraCalc){
        $this->idNaoGeraCalc = $geraCalc;
    }
    
    public function setDiasConsPeriodo($diasConsPeriodo){
        $this->qtdeDiasConsPeriodo = $diasConsPeriodo;
    }
    
    public function detalharDiasConsPeriodo($dados){
        $this->detalhesDiasConsPeriodo = $dados;
    }

    public function setResultadoTotal($total){
        $this->resultadoTotal = $total;
    }
    
    public function setInfoValesVinc($infos){
        $this->infoValesVinc[] = $infos;
    }
    
    public function setImpeditivosParaGerarVale($erros){
        $this->impeditivosParaGerarVale[] = $erros;
    }

    public static function getInstance() {
        if (self::$instance === null) {
            self::$contador++;
            self::$instance = new self();
        }

        return self::$instance;
    }

    public function clear()
    {
        self::$instance = null;
        self::$contador = 0;
    }
    

    public function getCaminhoArquivo(){
        return $this->arquivo;
    }
    
    public function concatenarMensagemVinc(){
        $escopoVinc = 
        PHP_EOL.PHP_EOL.
        '=-=-=-=-=-=-=- INFORMAÇÃO '.self::$contador.' -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-='.PHP_EOL.PHP_EOL.
        '_______________ ::::: Dados do vínculo'.PHP_EOL.PHP_EOL.    
        '* Nr. Vínculo: '.$this->vinculo->getNrvinculom().PHP_EOL.
        '* Nome Vínculo: '.$this->vinculo->getNmvinculom().PHP_EOL.
        '* Data Pagamento: '.$this->dtPagamento.PHP_EOL.
        '* Data Início Vale: '.$this->dtInicial.PHP_EOL.
        '* Data Fim Vale: '.$this->dtFinal.PHP_EOL.PHP_EOL
        ;
        
        $escopoVinc .=
        '_______________ ::::: Vales do vínculo'
        ;    
        if(count($this->infoValesVinc) > 0){
            foreach($this->infoValesVinc as $key=>$infoVale){
                $msg = 
                PHP_EOL.PHP_EOL.
                '_____ Vale '.($key+1).': '.PHP_EOL.PHP_EOL.
                'Nr. Linha: '.$infoVale['NRLINHATRANSP'].PHP_EOL.
                'Nr. Tarifa: '.$infoVale['NRTARIFA'].PHP_EOL.
                'Nr. Tipo Linha: '.$infoVale['NRTIPOLINHAVINC'].PHP_EOL.
                'Qt. Vale: '.$infoVale['QTLINHATARIFA'].PHP_EOL.
                'Vr. Tarifa: '.$infoVale['VRTARIFA'].PHP_EOL.
                //NEW
                (isset($infoVale['TPCALCVALE']) ? 'Tp. Calculo Vale: '.$infoVale['TPCALCVALE'].PHP_EOL : '').
                (isset($infoVale['IDDIASSEMANA']) ? 'Utiliza Nos Dias P/ Semana: '.$infoVale['IDDIASSEMANA'].PHP_EOL : '').
                (isset($infoVale['DIASDESCONTADOS']) ? 'Dias Desconsiderados: '.$infoVale['DIASDESCONTADOS'].PHP_EOL : '').
                //END
                'Dias considerados: '.$infoVale['DIAS'].PHP_EOL.
                'Valor Total: '.$infoVale['VALOR'].PHP_EOL.
                'Turno associado: '.(isset($infoVale['NRTURNO']) ? 'Sim' : 'Não').PHP_EOL.
                'Status: '.($infoVale['STATUS'] == true ? 'Calculado' : 'Não Calculado').PHP_EOL.
                'Motivo: '.$infoVale['MOTIVO']
                ;

                $escopoVinc .= $msg;
                
                if($infoVale['TPCALCVALE'] == 'Mensal'){
                    $this->geraInfoCalc = true;
                }
            }
        } else if(count($this->impeditivosParaGerarVale) > 0){
            foreach($this->impeditivosParaGerarVale as $key=>$erroVale){
               $msg = 
                PHP_EOL.PHP_EOL.
                'Status: '.($erroVale['STATUS'] == true ? 'Calculado' : 'Não Calculado').PHP_EOL.
                'Motivo: '.$erroVale['MOTIVO']
                ;
                
                $escopoVinc .= $msg; 
            }
        } else{
            $escopoVinc .= PHP_EOL.PHP_EOL."CALCULO GERADO: NENHUM VALE ENCONTRADO/VINCULO NAO TEM DIREITO A VALE".PHP_EOL;
        }
        
        if($this->geraInfoCalc == true){
            $escopoVinc .= PHP_EOL.PHP_EOL.
            '_______________ ::::: Detalhes do cálculo de dias'
            ;    
            
            $escopoVinc .= PHP_EOL.PHP_EOL.
            '_____ Geral: '.PHP_EOL.PHP_EOL
            ;
            
            if($this->referencia && $this->qtdeDiasComposicaoMensal){
                $escopoVinc .= 
                '* Status: Vale sem desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasComposicaoMensal'.PHP_EOL.
                '* Expressão: diasConsideracao = '.$this->qtdeDiasComposicaoMensal.PHP_EOL
                ;
            }
            elseif($this->referencia && $this->qtdeDiasObrigacaoSind){
                $escopoVinc .= 
                '* Status: Vale sem desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasObrigacaoSindicato'.PHP_EOL.
                '* Expressão: diasConsideracao = '.$this->qtdeDiasObrigacaoSind.PHP_EOL.PHP_EOL.
                '* diasConsideracao = '.$this->qtdeDiasObrigacaoSind.PHP_EOL
                ;
            }
            elseif($this->referencia && $this->qtdeDiasAviso){
                $escopoVinc .= 
                '* Status: Vale sem desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasAviso'.PHP_EOL.
                '* Expressão: diasConsideracao = '.$this->qtdeDiasAviso.PHP_EOL
                ;
            }
            elseif($this->referencia && $this->qtdeDiasConsPeriodo){
                $escopoVinc .= 
                '* Status: Vale sem desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasPeriodoCalc'.PHP_EOL.
                '* Expressão: diasConsideracao = '.$this->qtdeDiasConsPeriodo.PHP_EOL
                ;
            }elseif(!$this->referencia && $this->qtdeDiasComposicaoMensal){
                $expressao = $this->resultadoTotal.' = '.$this->qtdeDiasComposicaoMensal.' - '.$this->qtdeFerias.' - '.$this->qtdeFaltas.' - '.$this->qtdeDiasAfastAtest;
                $escopoVinc .= 
                '* Status: Vale com desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasComposicaoMensal - diasFerias - diasFaltas - Atestado/Afastamento'.PHP_EOL.
                '* Expressão: '.$expressao.PHP_EOL
                ;
    
                $escopoVinc .= $this->prepararDetalhesDiasPeriodoCalc();
                
                $escopoVinc .= $this->prepararDetalhesAtestAfast();
                
                $escopoVinc .= $this->prepararDetalhesFerias();
    
            }
            elseif(!$this->referencia && $this->qtdeDiasObrigacaoSind){
                $expressao = $this->resultadoTotal.' = '.$this->qtdeDiasObrigacaoSind.' - '.$this->qtdeFerias.' - '.$this->qtdeFaltas.' - '.$this->qtdeDiasAfastAtest;
                $escopoVinc .= 
                '* Status: Vale com desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasObrigacaoSindicato - diasFerias - diasFaltas - Atestado/Afastamento'.PHP_EOL.
                '* Expressão: '.$expressao.PHP_EOL
                ;
    
                $escopoVinc .= $this->prepararDetalhesDiasPeriodoCalc();
                
                $escopoVinc .= $this->prepararDetalhesAtestAfast();
                
                $escopoVinc .= $this->prepararDetalhesFerias();
    
            }
            elseif(!$this->referencia && $this->qtdeDiasAviso){
                $expressao = $this->resultadoTotal.' = '.$this->qtdeDiasAviso.' - '.$this->qtdeFerias.' - '.$this->qtdeFaltas.' - '.$this->qtdeDiasAfastAtest;
                $escopoVinc .= 
                '* Status: Vale com desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasAviso - diasFerias - diasFaltas - Atestado/Afastamento'.PHP_EOL.
                '* Expressão: '.$expressao.PHP_EOL
                ;
    
                $escopoVinc .= $this->prepararDetalhesDiasPeriodoCalc();
                
                $escopoVinc .= $this->prepararDetalhesAtestAfast();
                
                $escopoVinc .= $this->prepararDetalhesFerias();
    
            }
            elseif(!$this->referencia && $this->qtdeDiasConsPeriodo){
                $expressao = $this->resultadoTotal.' = '.$this->qtdeDiasConsPeriodo.' - '.$this->qtdeFerias.' - '.$this->qtdeFaltas.' - '.$this->qtdeDiasAfastAtest;
                $escopoVinc .= 
                '* Status: Vale com desconto de dias'.PHP_EOL.
                '* Fórmula: diasConsideracao = diasPeriodoCalc - diasFerias - diasFaltas - Atestado/Afastamento'.PHP_EOL.
                '* Expressão: '.$expressao.PHP_EOL
                ;
                
                $escopoVinc .= $this->prepararDetalhesDiasPeriodoCalc();
                
                $escopoVinc .= $this->prepararDetalhesAtestAfast();
                
                $escopoVinc .= $this->prepararDetalhesFerias();
            }
        }
        
        $this->unirEscopoVincEscopoGeral($escopoVinc);
        
        self::$contador++;

    }
    
    public function unirEscopoVincEscopoGeral($escopoVinc){
        $this->escopoGeral .= $escopoVinc;
    }
    
    public function prepararDetalhesDiasPeriodoCalc(){

        if($this->detalhesDiasConsPeriodo['tipo'] == 'turno'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ ::::: Detalhamento dias Consideração do Período'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesDiasConsPeriodo['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesDiasConsPeriodo['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesDiasConsPeriodo['resultado'].PHP_EOL.
            '* qtdeDiasTrabalhados (desconsiderando folgas): '.$this->detalhesDiasConsPeriodo['qtdeDiasTrabalhados'].PHP_EOL.
            '* feriados: '.$this->detalhesDiasConsPeriodo['feriados'].PHP_EOL.
            '* intersecaoFolgaFeriado: '.$this->detalhesDiasConsPeriodo['intersecaoFolgaFeriado'].PHP_EOL
            ;
        }elseif($this->detalhesDiasConsPeriodo['tipo'] == 'dsr'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ ::::: Detalhamento dias Consideração do Período'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesDiasConsPeriodo['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesDiasConsPeriodo['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesDiasConsPeriodo['resultado'].PHP_EOL.
            '* diasPeriodo: (considerando dsr) '.$this->detalhesDiasConsPeriodo['diasPeriodo'].PHP_EOL.
            '* dsr: '.$this->detalhesDiasConsPeriodo['dsr'].PHP_EOL.
            '* feriados: '.$this->detalhesDiasConsPeriodo['feriados'].PHP_EOL.
            '* intersecaoDsrFeriado : '.$this->detalhesDiasConsPeriodo['intersecaoDsrFeriado'].PHP_EOL
            ;
        }
        
        return $retorno;

    }
    
    public function prepararDetalhesAtestAfast(){
        $retorno = "";
        
        if(count($this->detalhesAfastAtest) > 0) $retorno = PHP_EOL.PHP_EOL.'_____ Detalhamento atestado/afastamento'.PHP_EOL.PHP_EOL;
        
        foreach($this->detalhesAfastAtest as $key => $detalheAfastAtest){
            if($detalheAfastAtest['tipo'] == 'turno'){
                $retorno .=
                '__ Atest/Afast '.($key+1).PHP_EOL.
                '* Dt. Inicial: '.$detalheAfastAtest['dtInicial'].PHP_EOL.
                '* Dt. Final: '.$detalheAfastAtest['dtFinal'].PHP_EOL.
                '* Fórmula: '.$detalheAfastAtest['formula'].PHP_EOL.
                '* Expressão: '.$detalheAfastAtest['expressao'].PHP_EOL.
                '* Resultado: '.$detalheAfastAtest['resultado'].PHP_EOL.
                '* diasTotaisAtestOuAfast: '.$detalheAfastAtest['diasTotaisAtestOuAfast'].PHP_EOL.
                '* feriados: '.$detalheAfastAtest['feriados'].PHP_EOL.
                '* diasFolga: '.$detalheAfastAtest['diasFolga'].PHP_EOL.
                '* intersecaoFolgaFeriado: '.$detalheAfastAtest['intersecaoFolgaFeriado'].PHP_EOL.PHP_EOL
                ;
            }elseif($detalheAfastAtest['tipo'] == 'dsr'){
                $retorno .=
                '__ Atest/Afast '.($key+1).PHP_EOL.
                '* Dt. Inicial: '.$detalheAfastAtest['dtInicial'].PHP_EOL.
                '* Dt. Final: '.$detalheAfastAtest['dtFinal'].PHP_EOL.
                '* Fórmula: '.$detalheAfastAtest['formula'].PHP_EOL.
                '* Expressão: '.$detalheAfastAtest['expressao'].PHP_EOL.
                '* Resultado: '.$detalheAfastAtest['resultado'].PHP_EOL.
                '* diasTotaisAtestOuAfast: '.$detalheAfastAtest['diasTotaisAtestOuAfast'].PHP_EOL.
                '* feriados: '.$detalheAfastAtest['feriados'].PHP_EOL.
                '* dsr: '.$detalheAfastAtest['dsr'].PHP_EOL.
                '* intersecaoDsrFeriado: '.$detalheAfastAtest['intersecaoDsrFeriado'].PHP_EOL.PHP_EOL
                ;
            }
        }
        
        return $retorno;

    }
    
    public function prepararDetalhesFerias(){
        $retorno = "";
        
        if($this->detalhesFerias['tipo'] == 'turno'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ Detalhamento Férias'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesFerias['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesFerias['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesFerias['resultado'].PHP_EOL.
            '* totalFerias: '.$this->detalhesFerias['totalFerias'].PHP_EOL.
            '* diasFolgaVinc: '.$this->detalhesFerias['diasFolgaVinc'].PHP_EOL.
            '* feriados: '.$this->detalhesFerias['feriados'].PHP_EOL.
            '* intersecaoFolgaFeriado: '.$this->detalhesFerias['intersecaoFolgaFeriado'].PHP_EOL
            ;
        }elseif($this->detalhesFerias['tipo'] == 'dsr'){
            $retorno =
            PHP_EOL.PHP_EOL.
            '_____ Detalhamento Férias'.PHP_EOL.PHP_EOL.
            '* Fórmula: '.$this->detalhesFerias['formula'].PHP_EOL.
            '* Expressão: '.$this->detalhesFerias['expressao'].PHP_EOL.
            '* Resultado: '.$this->detalhesFerias['resultado'].PHP_EOL.
            '* totalFerias: '.$this->detalhesFerias['totalFerias'].PHP_EOL.
            '* dsr: '.$this->detalhesFerias['dsr'].PHP_EOL.
            '* feriados: '.$this->detalhesFerias['feriados'].PHP_EOL.
            '* intersecaoDsrFeriado: '.$this->detalhesFerias['intersecaoDsrFeriado'].PHP_EOL
            ;
        }
        
        return $retorno;

    }
    
    public function retornarMensagemCompleta(){
        return $this->escopoGeral;
    }
    
    public function retornarMensagemVinc(){
        return $this->escopoVinc;
    }
    
    public function salvarMsgArquivo(){
        $this->arquivo = FPA::getTempDirectory().'/Memoria_VT  Execucao('.DateUtil::getDataAtual()->format('d-m-Y H:i:s').').txt';
        file_put_contents($this->arquivo, $this->escopoGeral);
    }

}